; TIP1103.LSP: UCSSTD.LSP  UCSs for Orhtographic Projections
;                              (c)1995, George Zinsmeister

; Creates named UCS's for the six principal views of standard orthographic
; projection.  After loading, type UCSSTD at the Command: prompt.  The named
; UCS's will be saved with the drawing so this function needs to be run only
; once.

(defun C:UCSSTD ( / CMDECHO)
   (setq CMDECHO (getvar "cmdecho"))   ;save current "cmdecho" system variable
   (setvar "cmdecho" 0)                              ;suppress command echoing
   (command "ucs" "s" "UCSTEMP")                             ;save current UCS
   (mapcar                         ;create a named UCS for each principal view
      '(lambda (AXIS ANGLE VIEW)
         (command "ucs" "d" VIEW "ucs" "w" "ucs" AXIS ANGLE "ucs" "s" VIEW)
      )
      '("x" "x" "x" "y" "y" "y")
      '(0 -90 90 90 -90 180)
      '("FRONT" "TOP" "BOTTOM" "RIGHT" "LEFT" "REAR")
   )
   (command "ucs" "r" "UCSTEMP" "ucs" "d" "UCSTEMP")     ;restore original UCS
   (setvar "cmdecho" CMDECHO)        ;restore original command echoing setting
   (princ)                                                  ;make a clean exit
)                                                                  ;end defun

; Creates six functions, C:FRONT, C:TOP, C:BOTTOM, C:RIGHT, C:LEFT, and
; C:REAR that can be used to recall the UCS's created with C:UCSSTD.  To
; recall a UCS type either FRONT, TOP, BOTTOM, RIGHT, LEFT, or REAR at the
; Command: prompt.  The UCS will be restored in its plan view.  This program
; file must be loaded whenever a drawing is started to redefine the six
; functions.

(foreach VIEW '("FRONT" "TOP" "BOTTOM" "RIGHT" "LEFT" "REAR")
   (set
      (read (strcat "C:" VIEW))           ;returns symbols C:FRONT, C:TOP, etc.
      (read                             ;defines functions C:FRONT, C:TOP, etc.
         (strcat
            "((/ CMDECHO)"
            "(setq CMDECHO (getvar \"cmdecho\"))"
            "(setvar \"cmdecho\" 0)"
            "(command \"ucs\" \"r\"\"" VIEW "\"\"plan\" \"c\")"
            "(setvar \"cmdecho\" CMDECHO) (princ))"
         )                                  ;end strcat
      )                                     ;end read
   )                                        ;end set
)                                           ;end foreach
(princ); end ucsstd.lsp                     ;make a clean exit
